#include <gb.h>

void PlacePerso(int x,int y,int image)
{
		set_sprite_tile(0,image*12+0);
		move_sprite(0, x, y);
		set_sprite_tile(1,image*12+2);
		move_sprite(1, x, y+8);
		set_sprite_tile(2,image*12+4);
		move_sprite(2, x, y+16);

		set_sprite_tile(3,image*12+6);
		move_sprite(3, x+8, y);
		set_sprite_tile(4,image*12+8);
		move_sprite(4, x+8, y+8);
		set_sprite_tile(5,image*12+10);
		move_sprite(5, x+8, y+16);

		set_sprite_tile(6,image*12+1);
		move_sprite(6, x, y);
		set_sprite_tile(7,image*12+3);
		move_sprite(7, x, y+8);
		set_sprite_tile(8,image*12+5);
		move_sprite(8, x, y+16);

		set_sprite_tile(9,image*12+7);
		move_sprite(9, x+8, y);
		set_sprite_tile(10,image*12+9);
		move_sprite(10, x+8, y+8);
		set_sprite_tile(11,image*12+11);
		move_sprite(11, x+8, y+16);
}

UBYTE TestCase(UBYTE _x,UBYTE _y)
{
	return (Map[_y/16][(_x-8)/16]==2) && (Map[_y/16][1+(_x-9)/16]==2) &&
	 (Map[1+(_y-9)/16][(_x-8)/16]==2) && (Map[1+(_y-9)/16][1+(_x-9)/16]==2);
}

UBYTE i,j,phase,dir,x_dir,y_dir,x,y,new_x,new_y,old_x,old_y,HauteurMenu,Menu;
UWORD ult;

void EcrireMenu(char Texte[])
{
	unsigned char Tmp[20*6],c;
	
	for (i=0;i<20*6;i++)
		Tmp[i] = Fenetre_tiles[i];
	i=0;
	j=21;
	while ((c=Texte[i])!='')
	{
		switch(c)
		{
		case '$':
			j=((j/20)+1)*20+1;
			break;
		default:
			Tmp[j++]=c;
		}
		i++;
	}
	set_win_tiles (0, 0, 20, 6, Tmp );
}

#define GAUCHE 0
#define DROITE 1
#define HAUT 2
#define BAS 3
//#define INVALID 255

UBYTE Sinus[]={ 0,0,1,1,1,2,2,3,4,4,5,5,5,6,6,6,6,6,5,5,5,4,4,3,2,2,1,1,1,0,0,0 };

void Test()
{
	UBYTE k=0;
	UBYTE t=0,u;
	UBYTE base = SCY_REG;
	while (!(joypad() & J_A))
	{
		u=t;
		for (k=0;k!=144;k++)
		{
			while (LY_REG!=k);
			SCY_REG = base + Sinus[u];
			u=(u+1)&31;
		}
		t++;
		SCY_REG = 0;
	}
}

void main()
{
	x=128;
	y=50;
	HauteurMenu=0;
	Menu=0; //Menu OFF
	disable_interrupts();
	DISPLAY_OFF;
	SPRITES_8x8;
	SHOW_SPRITES;
	SHOW_BKG;
	SHOW_WIN;

    set_sprite_palette( 0, 2, sprite_palette );

	set_bkg_data (0x20, 64, Font_data );
	set_win_data (0x60, 16, Fenetre_data );
VBK_REG = 1;
	set_win_tiles (0, 0, 20, 6, Fenetre_ctiles );
VBK_REG = 0;
	set_win_tiles (0, 0, 20, 6, Fenetre_tiles );
	set_bkg_palette (0, 8, back_palette );
	set_bkg_data (0, 16, back_data );
	EcrireMenu(Texte);
	for (j=0;j<16;j++)
		for (i=0;i<16;i++)
		{
			VBK_REG = 1;
			set_bkg_tiles(2*i,2*j,2,2,&cMotif[4*Map[j][i]]);
			VBK_REG = 0;
			set_bkg_tiles(2*i,2*j,2,2,&Motif[4*Map[j][i]]);
		}

	set_sprite_data(0x00, 144, spr_data);

	for (i=0;i<6;i++)
	{
		set_sprite_prop(i,0);
		set_sprite_prop(i+6,1);
	}

	DISPLAY_ON;
	enable_interrupts();
	dir = GAUCHE;
	while (1)
	{
		i=joypad();
		if (i)
		{
			old_x = x;
			old_y = y;
			new_x = x;
			new_y = y;
			
			if (i & J_LEFT)	{	x_dir = GAUCHE;	new_x = x-1;	}
			if (i & J_RIGHT){	x_dir = DROITE;	new_x = x+1;	}
			if (i & J_UP)	{	y_dir = HAUT;	new_y = y-1;	}
			if (i & J_DOWN)	{	y_dir = BAS;	new_y = y+1;	}
			if (i & J_SELECT && (HauteurMenu==0 || HauteurMenu==48)) { Menu = !Menu; }
			if (i & J_START) Test();

			if ((x!=new_x) && TestCase(new_x,y) )	{	x = new_x;	dir = x_dir;	}
			if ((y!=new_y) && TestCase(x,new_y) )	{	y = new_y;	dir = y_dir;	}

			if ((x!=old_x) || (y!=old_y))	phase = (phase + 1) % 4;

		}
		if (Menu && HauteurMenu<48) HauteurMenu++;
		if (!Menu && HauteurMenu) HauteurMenu--;
		wait_vbl_done();

		SCX_REG = (x-24)*(256L-160L)/208;
		ult = (y-16L)*(256L-(144L-HauteurMenu));
		SCY_REG = ult/216;
		WY_REG = 144U-HauteurMenu;
		PlacePerso(x-SCX_REG,y-SCY_REG,dir*3+(phase==3?1:phase));
	}
}
